var Ci = Components.interfaces;
var Cc = Components.classes;

var asw = {
  init: function() {
	  try { if(window.arguments[0]) window.opener=window.arguments[0]; } catch(e){}
	  asw.prefs=Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);
		asw.sandbox=[[],[],[]];
		asw.mayChange=false;
		
		min=asw.prefs.getIntPref('browser.search.minwidth');
    max=asw.prefs.getIntPref('browser.search.maxwidth');
    off=asw.prefs.getIntPref('browser.search.offset');  
    document.getElementById('cleanOnSubmit').checked=asw.prefs.getBoolPref('browser.search.cleanOnSubmit');
    document.getElementById('revertOnSubmit').checked=asw.prefs.getBoolPref('browser.search.revertOnSubmit');
		
		// Load prefs
		if(min==0 && max==off) {
		  path=1; // Alternative
			asw.text2desc('altWidthPixels',asw.lang('altWidth',max),false);
		  asw.sandbox[1][0]=0;
			asw.sandbox[1][1]=max;
			asw.sandbox[1][2]=max;
			// Guessing for fixed
			asw.sandbox[2][0]=max;
			asw.sandbox[2][1]=max;
			asw.sandbox[2][2]=off;
			// Guessing for normal
			asw.sandbox[0][1]=max;
			asw.sandbox[0][0]=0;
		} else if(min==max && min!=0) {
		  path=2; // Fixed
			asw.text2desc('fixWidthPixels',asw.lang('fixWidth',min),false);
		  asw.sandbox[2][0]=min;
			asw.sandbox[2][1]=min;
			asw.sandbox[2][2]=off;
			// Guessing for alt
			asw.sandbox[1][0]=0;
			asw.sandbox[1][1]=min;
			asw.sandbox[1][2]=min;
			// Guessing for normal
			asw.sandbox[0][1]=min;
			asw.sandbox[0][0]=0;
		} else {
		  path=0; // normal
			
			if(min==0) {
			  asw.text2desc('norMinWidthPixels',asw.lang('minWidthTitle',''),false);
			  asw.sandbox[0][0]=0;
			} else if(min==1) {
			  asw.text2desc('norMinWidthPixels',asw.lang('minWidthSmall',''),false);
			  asw.sandbox[0][0]=1;
			} else {
			  asw.text2desc('norMinWidthPixels',asw.lang('minWidthPx',min),false);
		    asw.sandbox[0][0]=min;
			}
			
			if(max==0) {
			  asw.text2desc('norMaxWidthPixels',asw.lang('maxWidthWide',''),false);
			  asw.sandbox[0][1]=0;
			} else {
			  asw.text2desc('norMaxWidthPixels',asw.lang('maxWidthPx',max),false);
		    asw.sandbox[0][1]=max;
				// Guessing for alt
				asw.sandbox[1][0]=0;
				asw.sandbox[1][1]=max;
				asw.sandbox[1][2]=max;
				// Guessing for fixed
				asw.sandbox[2][0]=max;
				asw.sandbox[2][1]=max;
				asw.sandbox[2][2]=off;
			}			
			asw.sandbox[2][2]=off;
		}
		
		document.getElementById('startBehaviour').selectedIndex=path;
		
		// Enable extra2 button manually
		extra2=document.getElementById('autosizer-install-wizard').getButton('extra2');
		extra2.removeAttribute('hidden');
		extra2.setAttribute('onclick',"window.openDialog('chrome://autosizer/content/prefs.xul', '_blank', 'chrome,titlebar,toolbar,centerscreen,dialog=no',window.opener);window.close();");
		extra2.label=asw.lang('buttonAdvanced','');
		extra2.setAttribute('accesskey',asw.lang('buttonAdvancedAccesskey',''));
	},
	
	lang: function(v,t) {
	  return document.getElementById("locale").getFormattedString(v, [t+'']);	
	},
	
	nextPageOnFirstPage: function() {
	  nextItemVal=document.getElementById('startBehaviour').selectedItem.value;
		if(nextItemVal=='normal') newPage='norMinWidth';
	  if(nextItemVal=='alternative') newPage='altWidth';		
		if(nextItemVal=='fixed') newPage='fixWidth';
	  document.getElementById('start').setAttribute('next',newPage);
	},

	canAdv: function(what) { 
	  document.getElementById('autosizer-install-wizard').canAdvance=what;
	},

	toggleSizing: function(what) { 	 
		asw.makeOnTop(what);		     
		asw.mayChange=what;
    
		if(what) {
      // Size searchbar according to page's text
			curPage=document.getElementById('autosizer-install-wizard').currentPage.pageid;	
			var value='nosize';
			if(curPage=='altWidth' && asw.sandbox[1][1]) value=asw.sandbox[1][1]+'';
			if(curPage=='fixWidth' && asw.sandbox[2][1]) value=asw.sandbox[2][1]+'';		
		  if(curPage=='norMinWidth' && typeof asw.sandbox[0][0] != "undefined") {
			  if(asw.sandbox[0][0]==0) value='label';
				else value=asw.sandbox[0][0];
			}  
			if(curPage=='norMaxWidth' && asw.sandbox[0][1]) {
			  if(asw.sandbox[0][1]==0) value='max';
				else value=asw.sandbox[0][1];
			}  		

		  asw.prefs.setCharPref('browser.search.manualResize',value);	
      
      // Focus/Open Window
			var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
			var win = wm.getMostRecentWindow("navigator:browser");
			if(win) win.focus();
			else {
			  asw.win=window.openDialog("chrome://browser/content/", "_blank", "chrome,all,dialog=no");
				setTimeout('asw.win._content.location="about:blank";',0);
			} 
			setTimeout("window.focus()",10);
      
		} else asw.prefs.setCharPref('browser.search.manualResize','');
		
    asw.prefs.setCharPref('browser.search.autosizerwizard','');		
		// Displaying the grippys is handled in autosizer.js/checkPrefs function.    
    setTimeout('asw.dragDropOsrv('+what+');',0);
	},
  
  dragDropOsrv: function(what) {
    if (!(asw.prefs instanceof Ci.nsIPrefBranchInternal)) return;    
    if (what) {
      asw.prefObserver = new AutosizerWizPrefObserver();
      asw.prefs.addObserver('', asw.prefObserver, false);
    } else if(asw.prefObserver) asw.prefs.removeObserver('',asw.prefObserver);
  },
	
	text2desc: function(id,text,bold) {
	  d=document.getElementById(id);
		if(d.hasChildNodes())
		  d.replaceChild(document.createTextNode(text),d.firstChild);
		else
		  d.appendChild(document.createTextNode(text));
		d.removeAttribute("value"); // Strangely it seems to appear from nowhere?!
		if(bold) d.setAttribute("style","font-weight:bold;");
	},

	manualSizingChange: function() {
	  if(!asw.mayChange) return;
	  try {
			newValue=asw.prefs.getCharPref('browser.search.autosizerwizard');
			newValue=newValue.split('|');
			if(newValue[0]==0 || newValue[0] == undefined) return;
			// width neededWidth tooltipwidth availableWidth focus?
      if(newValue[4]=='true') window.focus();
		} catch(e) { return; }
		asw.canAdv(true);
		
		curPage=document.getElementById('autosizer-install-wizard').currentPage.pageid;	
		if(curPage=='altWidth') {
		  asw.text2desc('altWidthPixels',asw.lang('altWidthChange',newValue[0]),true);
		  asw.sandbox[1][0]=0;
			asw.sandbox[1][1]=newValue[0];
			asw.sandbox[1][2]=newValue[0];
		}
		
		if(curPage=='fixWidth') {
			asw.text2desc('fixWidthPixels',asw.lang('fixWidthChange',newValue[0]),true);
		  asw.sandbox[2][0]=newValue[0];
			asw.sandbox[2][1]=newValue[0];
			asw.sandbox[2][2]=0;
		}
		
	  if(curPage=='norMinWidth') {
		  asw.sandbox[0][2]=0;
		  if(newValue[0]<newValue[1]*1+5) {
			  asw.text2desc('norMinWidthPixels',asw.lang('minWidthSmallChange',''),true);
			  asw.sandbox[0][0]=1;
			} else if(newValue[0]<newValue[2]*1+15 && newValue[0]>newValue[2]*1-15) {
			  asw.text2desc('norMinWidthPixels',asw.lang('minWidthTitleChange',''),true);
			  asw.sandbox[0][0]=0;
			} else {
			  asw.text2desc('norMinWidthPixels',asw.lang('minWidthPxChange',newValue[0]),true);
		    asw.sandbox[0][0]=newValue[0];
			}
		}
		
		if(curPage=='norMaxWidth') {
		  if(newValue[0]>newValue[3]*1-70) {
				asw.text2desc('norMaxWidthPixels',asw.lang('maxWidthWideChange',''),true);
			  asw.sandbox[0][1]=0;
			} else {
				asw.text2desc('norMaxWidthPixels',asw.lang('maxWidthPxChange',newValue[0]),true);
		    asw.sandbox[0][1]=newValue[0];
			}
		}
	},
	
	makeOnTop: function(what) {	  
    if(Cc["@mozilla.org/xre/app-info;1"].getService(Ci.nsIXULRuntime).OS.toLowerCase()=='darwin') return;
		try { // Thanks to console2 extension :)
		  var xulWin = window.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation).QueryInterface(Ci.nsIDocShellTreeItem).treeOwner.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIXULWindow);
			xulWin.zLevel = (what)?xulWin.highestZ:xulWin.normalZ;
		} catch(e) {}
	},
  
	savePrefs: function () {
	  var p=document.getElementById('startBehaviour').selectedIndex;
    var intP1=["minwidth","maxwidth","offset","labelOffset","autocompletePopupMinWidth"];
    var intP2=[asw.sandbox[p][0],asw.sandbox[p][1],asw.sandbox[p][2],2,200];
    for(p in intP1) asw.prefs.setIntPref('browser.search.'+intP1[p], intP2[p]);
    
    var boolP=["cleanOnSubmit","revertOnSubmit"]
    for(p in boolP) asw.prefs.setBoolPref('browser.search.'+boolP[p], document.getElementById(boolP[p]).checked);
		asw.cleanUp();
	},
	
	cleanUp: function() {
    asw.dragDropOsrv(false); // Force in case of cancel
	  asw.toggleSizing(false);
		asw.prefs.setCharPref('browser.search.autosizerwizard',''); 
		asw.prefs.setCharPref('browser.search.manualResize',''); 
		try { window.opener.focus(); } catch(e) {}
	}
}

function AutosizerWizPrefObserver() {
	asw.manualSizingChange();
}

AutosizerWizPrefObserver.prototype = {
  observe: function(subject, topic, pref) {
		if (topic == 'nsPref:changed' && pref=='browser.search.autosizerwizard') {
		  try { asw.manualSizingChange(); } catch(e) {}
		}
	}
};